package com.example.autocrossbow;

import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.client.event.lifecycle.v1.ClientTickEvents;
import net.fabricmc.fabric.api.client.keybinding.v1.KeyBindingHelper;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.option.KeyBinding;
import net.minecraft.client.util.InputUtil;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.CrossbowItem;
import net.minecraft.item.ItemStack;
import net.minecraft.text.Text;
import net.minecraft.util.Hand;

import org.lwjgl.glfw.GLFW;

public class AutoCrossbowMod implements ClientModInitializer {

    private static boolean enabled = false;
    private static KeyBinding toggleKeyBinding;
    private static boolean wasUsing = false;
    private static int chargeProgress = 0;

    @Override
    public void onInitializeClient() {
        toggleKeyBinding = KeyBindingHelper.registerKeyBinding(new KeyBinding(
                "key.autocrossbow.toggle",
                InputUtil.Type.KEYSYM,
                GLFW.GLFW_KEY_UNKNOWN, // 默认UNKNOW，自己去设置
                "category.autocrossbow"
        ));

        ClientTickEvents.END_CLIENT_TICK.register(client -> {
            while (toggleKeyBinding.wasPressed()) {
                enabled = !enabled;
                if (client.player != null) {
                    client.player.sendMessage(
                            Text.translatable("message.autocrossbow.status",
                                    Text.translatable(enabled ? "message.autocrossbow.enabled" : "message.autocrossbow.disabled")),
                            true
                    );
                }
            }

            if (!enabled || client.player == null || client.interactionManager == null) {
                return;
            }

            PlayerEntity player = client.player;
            Hand hand = Hand.MAIN_HAND;
            ItemStack stack = player.getStackInHand(hand);

            if (!(stack.getItem() instanceof CrossbowItem)) {
                return;
            }

            boolean isUsing = client.options.useKey.isPressed();

            if (CrossbowItem.isCharged(stack) && isUsing) {
                client.interactionManager.interactItem(player, hand);
                return;
            }

            if (isUsing) {
                if (!player.isUsingItem()) {
                    client.interactionManager.interactItem(player, hand);
                    chargeProgress = 0;
                }
                else if (player.getActiveHand() == hand) {
                    chargeProgress++;

                    int pullTime = CrossbowItem.getPullTime(stack, player);

                    // TODO 目前测试稳定的只有快速装填3，其他有待优化
                    if (chargeProgress >= pullTime * 1.1f) {
                        client.interactionManager.stopUsingItem(player);
                        wasUsing = true;
                    }
                }
            }
            else if (wasUsing) {
                wasUsing = false;
                chargeProgress = 0;
            }
        });
    }
}
